#if !defined HATP_MAIN_SESSION_MSG_HH_
#define HATP_MAIN_SESSION_MSG_HH_

#include<string>
#include<map>
#include<queue>
#include<boost/variant/variant.hpp>

#include "msgTypesTrait.hh"
#include "Plan.hh"

enum MainSessionMsg { NewPlan, Unknown, GetBestScore, BestScore, End, SolFound };

template <>
class MsgTypesTrait<MainSessionMsg>
{
public:

	typedef boost::variant<Plan*, std::string> messagingToA_type; // A is the main thread
	typedef boost::variant<std::map<std::string, float> const* > messagingToB_type; // B is the Planning Session thread

	static char toChar(MainSessionMsg m) {
		char res = 'm';
		switch (m) {
			case NewPlan : res = 'a'; break;
			case Unknown : res = 'b'; break;
			case GetBestScore : res = 'c'; break;
			case BestScore : res = 'd'; break;
			case End : res = 'e'; break;
			case SolFound : res = 'f'; break; // ju
		}
		return res;
	}

	static MainSessionMsg fromChar(char m) {
		MainSessionMsg res = Unknown;
		switch (m) {
			case 'a': res = NewPlan; break;
			case 'b': res = Unknown; break;
			case 'c': res = GetBestScore; break;
			case 'd': res = BestScore; break;
			case 'e': res = End; break;
			case 'f': res = SolFound; break; // ju
		}
		return res;
	}
};

#endif
